import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

/**
 *
 * @author Sjaak Smetsers & Renske Smetsers-Weeda
 * @version 3.1 -- 29-07-2017
 */
public class MyDodo extends Dodo
{
    /* ATTRIBUTE DECLARATIONS: */
    private int myNrOfStepsTaken;
           
    public MyDodo() {
        super( EAST );
        /* INITIALISATION OF ATTRIBUTES: */
        myNrOfStepsTaken = 0;
    }

    /* METHODS OF THE CLASS: */

    public void act() {
    }

    /**
     * Move one cell forward in the current direction.
     * 
     * <P> Initial: Dodo is somewhere in the world
     * <P> Final: If possible, Dodo has moved forward one cell
     *
     */
    public void move() {
        if ( canMove() ) {
            step();
        } else {
            showError( "I'm stuck!" );
        }
    }

    /**
     * Test if Dodo can move forward, 
     * i.e. there are no obstructions or end of world in the cell in front of her.
     * 
     * <p> Initial:   Dodo is somewhere in the world
     * <p> Final:     Same as initial situation
     * 
     * @return  boolean true if Dodo can move (thus, no obstructions ahead)
     *                  false if Dodo can't move
     *                      there is an obstruction or end of world ahead
     */
    public boolean canMove() {
        if ( borderAhead() || fenceAhead() ){
            return false;
        } else {
            return true;
        }
    }

    /**
     * Move given number of cells forward in the current direction.
     * 
     * <p> Initial:   
     * <p> Final:  
     * 
     * @param   int distance: the number of steps made
     */
    public void jump( int distance ) {
        int nrStepsTaken = 0;               // set counter to 0
        while ( nrStepsTaken < distance ) { // check if more steps must be taken  
            move();                         // take a step
            nrStepsTaken++;                 // increment the counter
        }
    }

    /**
    * Places all the Egg objects in the world in a list.
    * 
    * @return List of Egg objects in the world
    */
    public List<Egg> getListOfEggsInWorld() {
        return getWorld().getObjects(Egg.class);
    }
    
    public List<Integer> createListOfNumbers() {
        return new ArrayList<> (Arrays.asList( 2, 43, 7, -5, 12, 7 ));
    }
    

    /**
     * Method for praciticing with lists.
     */
    public void practiceWithLists( ){
        List<Integer> listOfNumbers = createListOfNumbers();
        System.out.println("First element: " + listOfNumbers.get(0) ); 
    }

    public void practiceWithListsOfSurpriseEgss( ){
        List<SurpriseEgg>  listOfEgss = SurpriseEgg.generateListOfSurpriseEggs( 12, getWorld() );
    }
    
    
    /**
     * Test if given coordinates are in the world
     *
     * <p>Initial: Dodo is in the world
     * <p>Final: Same as initial.
     *
     * @return boolean true if coordinates are in the world
     * false if coordinates fall outside the world
     *
     * @param int coordX: the X-coordinate of the destination
     * @param int coordY: the Y-coordinate of the destination
     */
    public boolean validCoordinates(int coordX, int coordY){
        World world = getWorld(); // get the world
        if( (coordX >= 0 && coordX <= world.getWidth()-1 ) && ( coordY >= 0 && coordY <=
            world.getHeight()-1 ) ) {
            return true;
        }else{
            showError( "Invalid coordinates" );
            return false;
        }
    }

    /**
     * Test if Dodo is at particular coordinates are in the world
     *
     * <p>Initial: Dodo is in the world
     * <p>Final: Same as initial.
     *
     * @return boolean true if Dodo is at given coordinates
     * false if Dodo isn’t at given coordinates
     *
     * @param int coordX: the X-coordinate at the desired location
     * @param int coordY: the Y-coordinate at the desired location
     */
    public boolean locationReached(int coordX, int coordY){
        if ( coordX == getX() && coordY == getY()){
            return true;
        } else {
            return false;
        }
    }

    /**
     * Moves Dodo to the given coordinates ( coordX, coordY ), if possible.
     *
     * <p> Initial: Dodo is in the world
     * <p> Final: Dodo has moved to the given coordinates.
     * If the coordinates are not valid, final situation is equal to initial
     *
     * @param int coordX: the X-coordinate of the destination
     * @param int coordY: the Y-coordinate of the destination
     */
    public void goToLocation ( int coordX , int coordY ){
        if( validCoordinates ( coordX, coordY ) ){
            while (! locationReached( coordX, coordY ) ){
                if( coordX < getX() ){
                    setDirection(WEST); //turn facing west
                }
                if(coordX > getX() ) {
                    setDirection(EAST); //turn facing east
                }
                if( coordY < getY() ) {
                    setDirection(NORTH); //turn facing north
                }
                if( coordY > getY() ) {
                    setDirection(SOUTH); //turn facing sounth
                }
                move();
            }
        }else {
            showError("invalid coordinates");
        }
    }

}
